//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|            Close Routine
//|        Last Updated 8-8-2008 
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

#property copyright "Skyview Innovations LLC"
#property link      "kmitchell72774@yahoo.com"
#define NL          "\n" 

extern double ProfitTarget              = 75.0;    // closes all orders once Profit hits this $ amount
extern bool   CloseNumberNow            = false;  // closes all orders now regardless of profit
extern int    Number1                   = 0; 
extern int    Number2                   = 0; 
extern int    Number3                   = 0; 
extern int    Number4                   = 0; 
extern int    Number5                   = 0; 
extern int    Number6                   = 0; 
extern int    Number7                   = 0; 
extern int    Number8                   = 0; 
extern int    Number9                   = 0; 
extern int    Number10                  = 0; 
extern bool   CloseProfitableTradesOnly = false;  // closes only profitable trades, SWAP NOT INCLUDED
extern bool   includeSwapnCommission    = false;  // make true to include Swap and Commission in close amount  
extern double ProfitableTradeAmount     = 1;      // Only trades above this amount close out
extern bool   ClosePendingOnly          = false;  // closes pending orders only
extern bool   UseEmail                  = false;  // Set your email up under tools/options to have emails sent at close
extern bool   UseAlerts                 = false;  //
extern bool   CloseAllNow               = false;  // closes all orders now regardless of profit

double   LowMarginPercent = 100000000, LowestDrawDown=10000000, MaxProfit=-100000;

//+-------------+
//| Custom init |
//|-------------+

int init()
  {
  }

//+----------------+
//| Custom DE-init |
//+----------------+

int deinit()
  {

  }

//+------------------------------------------------------------------------+
//| Closes everything
//+------------------------------------------------------------------------+

void CloseAll()
{
  for(int i=OrdersTotal()-1;i>=0;i--)
  {
    if (OrderSelect(i, SELECT_BY_POS))
    {
      if (OrderMagicNumber() == Number1 || OrderMagicNumber() == Number2 || OrderMagicNumber() == Number3 ||
          OrderMagicNumber() == Number4 || OrderMagicNumber() == Number5 || OrderMagicNumber() == Number6 ||
          OrderMagicNumber() == Number7 || OrderMagicNumber() == Number8 || OrderMagicNumber() == Number9 ||
          OrderMagicNumber() == Number10 ||
          OrderTicket() == Number1 || OrderTicket() == Number2 || OrderTicket() == Number3 || OrderTicket() == Number4 ||
          OrderTicket() == Number5 || OrderTicket() == Number6 || OrderTicket() == Number7 || OrderTicket() == Number8 ||
          OrderTicket() == Number9 || OrderTicket() == Number10)
        { 
      bool result = false;
        if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if ( OrderType() == OP_SELL) result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
        if ( OrderType()== OP_BUYSTOP)   result = OrderDelete( OrderTicket() );
        if ( OrderType()== OP_SELLSTOP)  result = OrderDelete( OrderTicket() );
        if ( OrderType()== OP_BUYLIMIT)  result = OrderDelete( OrderTicket() );
        if ( OrderType()== OP_SELLLIMIT) result = OrderDelete( OrderTicket() );
        if (UseAlerts) PlaySound("alert.wav");
        }
     }
   }
     if(UseEmail) SendMail("Alert", "All Orders Closed!!  Account Balance = " +AccountBalance());
  return; 
}
   
//+------------------------------------------------------------------------+
//| Closes everything with certain MagicNumber or OrderTicket number
//+------------------------------------------------------------------------+

void CloseNumber()
{
  for(int i=OrdersTotal()-1;i>=0;i--)
  {
    if (OrderSelect(i, SELECT_BY_POS))
    {
      if (OrderMagicNumber() == Number1 || OrderMagicNumber() == Number2 || OrderMagicNumber() == Number3 ||
          OrderMagicNumber() == Number4 || OrderMagicNumber() == Number5 || OrderMagicNumber() == Number6 ||
          OrderMagicNumber() == Number7 || OrderMagicNumber() == Number8 || OrderMagicNumber() == Number9 ||
          OrderMagicNumber() == Number10 ||
          OrderTicket() == Number1 || OrderTicket() == Number2 || OrderTicket() == Number3 || OrderTicket() == Number4 ||
          OrderTicket() == Number5 || OrderTicket() == Number6 || OrderTicket() == Number7 || OrderTicket() == Number8 ||
          OrderTicket() == Number9 || OrderTicket() == Number10)
        {    
      bool result = false;
        if ( OrderType() == OP_BUY && OrderProfit()>=ProfitTarget)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if ( OrderType() == OP_SELL && OrderProfit()>=ProfitTarget) result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
        if (UseAlerts) PlaySound("alert.wav");
        }
     }
   }
     if(UseEmail) SendMail("Alert", "All Orders Closed!!  Account Balance = " +AccountBalance());
  return; 
}

//+------------------------------------------------------------------------+
//| cancels all orders that are in profit
//+------------------------------------------------------------------------+

void CloseAllinProfit()
{
  for(int i=OrdersTotal()-1;i>=0;i--)
  {
    if (OrderSelect(i, SELECT_BY_POS))
    {
      if (OrderMagicNumber() == Number1 || OrderMagicNumber() == Number2 || OrderMagicNumber() == Number3 ||
          OrderMagicNumber() == Number4 || OrderMagicNumber() == Number5 || OrderMagicNumber() == Number6 ||
          OrderMagicNumber() == Number7 || OrderMagicNumber() == Number8 || OrderMagicNumber() == Number9 ||
          OrderMagicNumber() == Number10 ||
          OrderTicket() == Number1 || OrderTicket() == Number2 || OrderTicket() == Number3 || OrderTicket() == Number4 ||
          OrderTicket() == Number5 || OrderTicket() == Number6 || OrderTicket() == Number7 || OrderTicket() == Number8 ||
          OrderTicket() == Number9 || OrderTicket() == Number10)
        { 
      bool result = false;
        if (includeSwapnCommission && OrderType() == OP_BUY && OrderProfit()+OrderSwap()+OrderCommission()>ProfitableTradeAmount)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if (includeSwapnCommission && OrderType() == OP_SELL && OrderProfit()+OrderSwap()+OrderCommission()>ProfitableTradeAmount)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
        if ( OrderType() == OP_BUY && OrderProfit()>ProfitableTradeAmount)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
        if ( OrderType() == OP_SELL && OrderProfit()>ProfitableTradeAmount)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
        if (UseAlerts) PlaySound("alert.wav");
        }
     }
 }
  return; 
}

//+------------------------------------------------------------------------+
//| cancels all pending orders 
//+------------------------------------------------------------------------+

void ClosePendingOrdersOnly()
{
  for(int i=OrdersTotal()-1;i>=0;i--)
  {
    if (OrderSelect(i, SELECT_BY_POS))
    {
      if (OrderMagicNumber() == Number1 || OrderMagicNumber() == Number2 || OrderMagicNumber() == Number3 ||
          OrderMagicNumber() == Number4 || OrderMagicNumber() == Number5 || OrderMagicNumber() == Number6 ||
          OrderMagicNumber() == Number7 || OrderMagicNumber() == Number8 || OrderMagicNumber() == Number9 ||
          OrderMagicNumber() == Number10 ||
          OrderTicket() == Number1 || OrderTicket() == Number2 || OrderTicket() == Number3 || OrderTicket() == Number4 ||
          OrderTicket() == Number5 || OrderTicket() == Number6 || OrderTicket() == Number7 || OrderTicket() == Number8 ||
          OrderTicket() == Number9 || OrderTicket() == Number10)
        { 
    bool result = false;
        if ( OrderType()== OP_BUYSTOP)   result = OrderDelete( OrderTicket() );
        if ( OrderType()== OP_SELLSTOP)  result = OrderDelete( OrderTicket() );
        if ( OrderType()== OP_BUYLIMIT)   result = OrderDelete( OrderTicket() );
        if ( OrderType()== OP_SELLLIMIT)  result = OrderDelete( OrderTicket() );
        }
      }
  }
  return; 
  }

//+-----------+
//| Main      |
//+-----------+

int start()
  {
   int      OrdersBUY, OrdersSELL;
   double   BuyLots, SellLots, BuyProfit, SellProfit, CurrentSwap, CurrentProfit;
   double   Profit, MarginPercent;
   string   Message;
   
//+------------------------------------------------------------------+
//  Determine last order price                                       |
//-------------------------------------------------------------------+
  for(int i=0;i<OrdersTotal();i++)
  {
    if (OrderSelect(i, SELECT_BY_POS))
    {
      if (OrderMagicNumber() == Number1 || OrderMagicNumber() == Number2 || OrderMagicNumber() == Number3 ||
          OrderMagicNumber() == Number4 || OrderMagicNumber() == Number5 || OrderMagicNumber() == Number6 ||
          OrderMagicNumber() == Number7 || OrderMagicNumber() == Number8 || OrderMagicNumber() == Number9 ||
          OrderMagicNumber() == Number10 ||
          OrderTicket() == Number1 || OrderTicket() == Number2 || OrderTicket() == Number3 || OrderTicket() == Number4 ||
          OrderTicket() == Number5 || OrderTicket() == Number6 || OrderTicket() == Number7 || OrderTicket() == Number8 ||
          OrderTicket() == Number9 || OrderTicket() == Number10)
        { 
        
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if(OrderType() == OP_BUY)  BuyProfit += OrderProfit();
           if(OrderType() == OP_SELL)  SellProfit += OrderProfit();
           CurrentSwap += OrderSwap();
           Profit+=OrderProfit();
      } 
    }
  }              
   
    if (AccountMargin()!=0) MarginPercent = MathRound((AccountEquity() / AccountMargin()) * 100);
    if (Profit < LowestDrawDown) LowestDrawDown = Profit;
    if (Profit > MaxProfit) MaxProfit = Profit;
    if (MarginPercent < LowMarginPercent && MarginPercent >0) LowMarginPercent = MarginPercent;

    if(CloseAllNow) CloseAll();
         
    if(CloseNumberNow) CloseNumber();

    if(CloseProfitableTradesOnly) CloseAllinProfit();
    
    if(BuyProfit+SellProfit >= ProfitTarget) CloseAll(); 
     
    if(ClosePendingOnly) ClosePendingOrdersOnly();
       
     
   Message = " \n ProfitTarget            " + DoubleToStr(ProfitTarget, 2) + NL +
             " Buy Orders             " + OrdersBUY + NL +
             " BuyLots                  " + DoubleToStr(BuyLots, 2) + NL +
             " BuyProfit               " + DoubleToStr(BuyProfit, 2) + NL + NL +
             " Sell Orders             " + OrdersSELL + NL +
             " SellLots                  " + DoubleToStr(SellLots, 2) + NL +
             " SellProfit                " + DoubleToStr(SellProfit, 2) + NL + NL +
             " Balance                  " + DoubleToStr(AccountBalance(), 2) + NL +
             " Equity                   " + DoubleToStr(AccountEquity(), 2) + NL +
             " Margin                   " + DoubleToStr(AccountMargin(), 2) + NL +
             " MarginPercent         " + DoubleToStr(MarginPercent, 2) + NL +
             " LowMarginPercent   " + DoubleToStr(LowMarginPercent, 2) + NL + NL +
             " Current Profit/Loss    " + DoubleToStr(Profit, 2) + NL +
             " Current Swap          " + DoubleToStr(CurrentSwap, 2) + NL +
             " Lowest                   " + DoubleToStr(LowestDrawDown, 2) + NL +
             " Max Profit               " + DoubleToStr(MaxProfit, 2) + NL + NL +
             " Current Time is       " +  TimeToStr(TimeCurrent(), TIME_SECONDS) + NL +
             " " +Month() + "-" + Day() + "-" + Year();   

   Comment(Message); 

} // start()


